# I added this because it made my life a lot easier when
from __future__ import print_function
# the 'end = ...' function was added in the print function that I didn't know a nice way to do
# in Python 2.7, so print statements must all have brackets in this version, no need in the server though
# Echo client program
import random
import time
import os
import platform
import setupngrok


socket = setupngrok.socket

# APPLICATION
partnerid = -1  # no partner
numberbidders = 0  # will be given by server
artists = ['Picasso', 'Rembrandt', 'Van_Gogh', 'Da_Vinci']

# DO SOMETHING HERE
# you need to change this to do something much more clever


def determinebid(itemsinauction, winnerarray, winneramount, numberbidders, players, mybidderid, artists, standings, round):
    if round != 0:
        # Determine which artist the player is currently focusing on
        my_artist = determine_my_artist(
            standings, itemsinauction, round, players)
        # Determine the amount of money I have left
        my_budget = standings[mybidderid]['money']
        my_artist_count = standings[mybidderid][my_artist]
        if my_artist == itemsinauction[round]:
            if standings[mybidderid][my_artist] == 2:
                return my_budget

            if my_artist_count == 0:
                max_bid = my_budget//3 + 1
                return max_bid
            else:
                max_bid = (my_budget//(3-my_artist_count)) + 2
                return max_bid
        else:
            if my_artist_count == 2:
                return 5
            return 11

    return 7


def determine_my_artist(standings, itemsinauction, round, players):
    # Determine the artist that I currently have the most items of
    my_artist = None
    my_artist_count = 0
    for artist, count in standings[mybidderid].items():
        if artist == 'money':
            continue
        if count > my_artist_count:
            my_artist_count = count
            my_artist = artist

    if my_artist == None:
        art_to_count_among_opponents = {}
        for opponent in players:
            if opponent == mybidderid:
                continue
            opponent_frequent_art = most_frequent_painting(opponent, standings)
            if opponent_frequent_art in art_to_count_among_opponents:
                art_to_count_among_opponents[opponent_frequent_art] += 1
            else:
                art_to_count_among_opponents[opponent_frequent_art] = 1

        resultList = list(art_to_count_among_opponents.items())
        if len(resultList) <= 1:
            my_artist = find_2nd_most_art(itemsinauction, round)
        else:
            resultList.sort(key=lambda x: x[1], reverse=True)
            my_artist = resultList[1]

    return my_artist


def find_2nd_most_art(itemsinauction, round):
    art_to_freq = {}
    for painting in itemsinauction[round:round+12]:
        if painting in art_to_freq:
            art_to_freq[painting] += 1
        else:
            art_to_freq[painting] = 1
    resultList = list(art_to_freq.items())
    resultList.sort(key=lambda pair: pair[1], reverse=True)
    return resultList[1][0]


def most_frequent_painting(teamid, standing):
    max_freq = 0
    max_freq_art = None
    for art, count in standing[teamid].items():
        if count >= max_freq:
            max_freq = count
            max_freq_art = art
    return max_freq_art


# this is the only thing that distinguishes the clients
mybidderid = 'zulfkhar_aisha'
moneyleft = 100  # should change over time
winnerarray = []  # who won each round
winneramount = []  # how much they paid

itemsinauction = []
myTypes = {'Picasso': 0, 'Rembrandt': 0,
           'Van_Gogh': 0, 'Da_Vinci': 0, 'money': moneyleft}

# EXECUTION

# get list of items and types
getlistflag = 1
socket.send((str(mybidderid)).encode())
while (getlistflag == 1):
    data = socket.recv(5024)
    x = (data.decode("utf-8")).split(" ")
    # print "Have received response at ", str(mybidderid), " of: ", ' '.join(x)
    # Receives first how many players are in the game and then all 200 items in auction
    if (x[0] != "Not" and len(data) != 0):
        getlistflag = 0
        numberbidders = int(x[0])
        itemsinauction = x[1:]
    else:
        time.sleep(2)

while True:
    socket.send((str(mybidderid) + ' ').encode())
    data = socket.recv(5024)
    x = (data.decode("utf-8")).split(" ")
    # Wait until everyone has connected before bidding
    if (x[0] == 'wait'):
        continue
    # When everyone has connected the server knows all names
    # it can therefore transfer all the names after telling the client that it's ready
    players = []
    for player in range(1, numberbidders + 1):
        players.append(x[player])
    break
# Create initial standings for each player after everyone connected
standings = {name: {'Picasso': 0, 'Van_Gogh': 0, 'Rembrandt': 0,
                    'Da_Vinci': 0, 'money': 100} for name in players}
# now do bids
continueflag = 1
j = 0
if platform.system() == 'Windows':
    os.system('cls')
else:
    os.system('clear')
while (continueflag == 1):
    # roundStart = time.time()
    print(random.choice(["I'm doing my best, okay?", "Why aren't you cheering louder?", "Aren't you proud of me?", "Damn I'm good, and I don't even have a brain!", "And do you think you could do any better?",
          "I feel like it's me doing all the work, you're just chilling in your chair", "If I lose this it's your fault not mine... I'm doing EXACTLY what you told me to do!"]))
    print()
    bidflag = 1
    bid = determinebid(itemsinauction, winnerarray, winneramount, numberbidders,
                       players, mybidderid, artists, standings, len(winnerarray))
    # sleep before sending the bid to make sure the server is ready, currently it's at a very big value 1
    # this should make it safe for any speed of computers or internet, but can probably be lower as I have had
    # it working on Wifi with my computer at 0.2
    time.sleep(1)
    socket.send((str(mybidderid) + " " + str(bid)).encode())
    while (bidflag == 1):
        # print "Have sent data from ", str(mybidderid)
        data = socket.recv(5024)
        x = (data.decode("utf-8")).split(" ")
        # print "Have received response at ", str(mybidderid), " of: ", ' '.join(x)
        if (x[0] != "Not"):
            bidflag = 0
        else:
            print("exception")
            time.sleep(2)

    resultflag = 1
    while (resultflag == 1):
        socket.send((str(mybidderid)).encode())
        # print "Have sent data from ", str(mybidderid)
        data = socket.recv(5024)
        x = (data.decode("utf-8")).split(" ")
        # Wait for all bids to be received
        if (x[0] == 'wait'):
            continue
        # print "Have received response at ", str(mybidderid), " of: ", ' '.join(x)
        # Check if the server told client that game is finished
        if len(x) >= 7 and x[7] == 'won.':
            time.sleep(5)
            continueflag = 0
            resultflag = 0
            print(data)
            print()
            print('game over')
        # Else update standings, winnerarray etc.
        if (x[0] != "ready") and (continueflag == 1):
            # roundLength = time.time()-roundStart
            # time.sleep(max(0, 5-roundLength))
            resultflag = 0
            if platform.system() == 'Windows':
                os.system('cls')
            else:
                os.system('clear')
            # print x
            winnerarray.append(x[0])
            winneramount.append(int(x[5]))
            standings[x[0]]['money'] -= int(x[5])
            standings[x[0]][x[3]] += 1
            if (x[0] == mybidderid):
                moneyleft -= int(x[5])
                myTypes[itemsinauction[j]] += 1
            # update moneyleft, winnerarray
        else:
            time.sleep(2)
    j += 1
